import pulumi
import pulumi_digitalocean as digitalocean

from utils import IP_ADDRESSES

smtp_2_go_out_allow = digitalocean.Firewall(
    "smtp-2-go-out-allow",
    name="smtp-2-go-out-allow",
    outbound_rules=[
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="465",
            protocol="tcp",
        )
    ],
    tags=["gitlab"],
    opts=pulumi.ResourceOptions(),
)

# TODO Delete
ssh_from_audrid = digitalocean.Firewall(
    "ssh-from-audrid",
    inbound_rules=[
        digitalocean.FirewallInboundRuleArgs(
            port_range="22",
            protocol="tcp",
        )
    ],
    name="ssh-from-audrid",
    tags=["gitlab"],
    opts=pulumi.ResourceOptions(),
)

web_server = digitalocean.Firewall(
    "web-server",
    inbound_rules=[
        digitalocean.FirewallInboundRuleArgs(
            port_range="80",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="443",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
    ],
    name="web-server",
    outbound_rules=[
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="80",
            protocol="tcp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="443",
            protocol="tcp",
        ),
    ],
    tags=[
        "gitlab",
        "webserver",
    ],
    opts=pulumi.ResourceOptions(),
)

mailserver = digitalocean.Firewall(
    "mailserver",
    inbound_rules=[
        digitalocean.FirewallInboundRuleArgs(
            port_range="587",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="25",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="143",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="993",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
    ],
    name="mailserver",
    outbound_rules=[
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="25",
            protocol="tcp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="587",
            protocol="tcp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="143",
            protocol="tcp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="993",
            protocol="tcp",
        ),
    ],
    tags=["mailserver"],
    opts=pulumi.ResourceOptions(),
)

ssh_from_cremona = digitalocean.Firewall(
    "ssh-from-cremona",
    inbound_rules=[
        digitalocean.FirewallInboundRuleArgs(
            port_range="22",
            protocol="tcp",
            source_addresses=IP_ADDRESSES,
        )
    ],
    name="ssh-from-cremona",
    tags=["ssh"],
    opts=pulumi.ResourceOptions(),
)

cremona_comms = digitalocean.Firewall(
    "cremona-comms",
    inbound_rules=[
        digitalocean.FirewallInboundRuleArgs(
            port_range="22",
            protocol="tcp",
            source_addresses=["81.187.162.136"],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="51820",
            protocol="udp",
            source_addresses=["81.187.162.136"],
        ),
    ],
    name="cremona-comms",
    outbound_rules=[
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=["81.187.162.136"],
            port_range="51820",
            protocol="udp",
        )
    ],
    opts=pulumi.ResourceOptions(),
)

base_config = digitalocean.Firewall(
    "base-config",
    inbound_rules=[
        digitalocean.FirewallInboundRuleArgs(
            protocol="icmp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        )
    ],
    name="base-config",
    outbound_rules=[
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="53",
            protocol="udp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            protocol="icmp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="80",
            protocol="tcp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="53",
            protocol="tcp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="443",
            protocol="tcp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="123",
            protocol="udp",
        ),
    ],
    tags=["firewalled"],
    opts=pulumi.ResourceOptions(),
)

out_http_https_dns_udp_only = digitalocean.Firewall(
    "out-http-https-dns-udp-only",
    name="out-http-https-dns-udp-only",
    outbound_rules=[
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="53",
            protocol="udp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            protocol="icmp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="80",
            protocol="tcp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="443",
            protocol="tcp",
        ),
    ],
    opts=pulumi.ResourceOptions(),
)

matrix = digitalocean.Firewall(
    "matrix",
    inbound_rules=[
        digitalocean.FirewallInboundRuleArgs(
            port_range="49152-49172",
            protocol="udp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="80",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="5349",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="3478",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="5349",
            protocol="udp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="3478",
            protocol="udp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="22",
            protocol="tcp",
            source_addresses=[
                "213.205.241.64",
                "81.187.162.136",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="10000",
            protocol="udp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="8448",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="443",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="4443",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
    ],
    name="matrix",
    outbound_rules=[
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="all",
            protocol="udp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            protocol="icmp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="all",
            protocol="tcp",
        ),
    ],
    tags=["matrix"],
    opts=pulumi.ResourceOptions(),
)

http_and_ssh_from_cremona_no_outbound = digitalocean.Firewall(
    "http-and-ssh-from-cremona-no-outbound",
    droplet_ids=[5164386],
    inbound_rules=[
        digitalocean.FirewallInboundRuleArgs(
            port_range="80",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="22",
            protocol="tcp",
            source_addresses=["145.224.65.220"],
        ),
        digitalocean.FirewallInboundRuleArgs(
            port_range="443",
            protocol="tcp",
            source_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
        ),
    ],
    name="http-and-ssh-from-cremona-no-outbound",
    outbound_rules=[
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="123",
            protocol="tcp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="53",
            protocol="udp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            protocol="icmp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="80",
            protocol="tcp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="443",
            protocol="tcp",
        ),
        digitalocean.FirewallOutboundRuleArgs(
            destination_addresses=[
                "0.0.0.0/0",
                "::/0",
            ],
            port_range="123",
            protocol="udp",
        ),
    ],
    opts=pulumi.ResourceOptions(),
)
